#include "Adafruit_GFX.h"
#include "glcdfont.c"
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <util/delay.h>
#include "uart.h"
#include "TouchScreen.h"
#include "Programs.h"

 #define BOXSIZE 40
 #define MINPRESSURE 200
 #define MAXPRESSURE 1000
 #define PENRADIUS 4
 #define TS_MINX 150
 #define TS_MINY 120
 #define TS_MAXX 920
 #define TS_MAXY 940

  //General colors
 #define	BLACK           0x0000
 #define 	WHITE           0xFFFF
 #define	RED             0xF800
 #define 	YELLOW          0xFFE0 
 #define	GREEN           0x07E0
 #define 	CYAN            0x07FF
 #define	BLUE            0x001F
 #define 	MAGENTA         0xF81F
 #define	GREY			50712
 #define    ORANGE			64800
 #define	PINK			63733
 #define	BROWN			35362

 // Declare sum variable
int sum;

// Move number of the user
int user_move = 1;

// Function to determine amount of nonzero elements in used array
int sum_used(int used[9])
{
	int sum = 0;
	int i;
	for (i=0; i<10; i++) {
		sum = sum + (used[i] != 0);
	}
	return sum;
} 

void tictactoe()
{
    //Touch Variables
    int x;
	int y;
	int yy;
	uint16_t z;
	int pen_size = PENRADIUS;
	//Tic-Tac-Toe Variables
	int difficulty=0;	
	int used[9]={0,0,0,0,0,0,0,0,0};
	int touched=0;
	int touch_index=0;
	int win=0;
	int player=0;
	int cpu=0;
	int tie=0;
	int cpu_move=0;
	int cpu_start=0;
	int move=0;
	char buff[10];
	// Determine on what move the user occupied a certain space
	int user[9] = {0, 0, 0, 0, 0, 0, 0, 0, 0};	
	for (int i=0; i<9;i++)
	{
		used[i]=0;
		user[i]=0;
	}
	user_move=1;
	fillScreen(BLACK);
	setTextColor(WHITE);
	setCursor(5,0);
	setTextSize(2);
  	drawString("Player\n");
	setCursor(105,0);
	drawString("Tie\n");
	setCursor(190,0);
	drawString("CPU\n");
	setTextSize(4);
	setCursor(25,25);
	drawString("0\n");
	setCursor(112,25);
	drawString("0\n");
	setCursor(197,25);
	drawString("0\n");
	fillRect(20,65,90, 30,GREY);
	fillRect(130,65,90, 30,GREY);
	setTextSize(2);
	setCursor(43,72);
	setTextColor(BLACK);
	drawString("EASY\n");
	setCursor(153,72);
	drawString("HARD\n");
	drawRect(20, 65, 90, 30, BLUE);
	drawRect(20+1, 65+1, 90-2, 30-2, BLUE);
	drawRect(20+2, 65+2, 90-3, 30-3, BLUE);
	drawLine(79,100,79,316,BLUE);
	drawLine(80,100,80,316,BLUE);
	drawLine(81,100,81,316,BLUE);
	drawLine(82,100,82,316,BLUE);
	drawLine(160,100,160,316,BLUE);
	drawLine(161,100,161,316,BLUE);
	drawLine(162,100,162,316,BLUE);
	drawLine(163,100,163,316,BLUE);
	drawLine(10,170,230,170,BLUE);
	drawLine(10,171,230,171,BLUE);
	drawLine(10,172,230,172,BLUE);
	drawLine(10,173,230,173,BLUE);
	drawLine(10,244,230,244,BLUE);
	drawLine(10,245,230,245,BLUE);
	drawLine(10,246,230,246,BLUE);
	drawLine(10,247,230,247,BLUE);
	while(1)
	{
		cpu_move = rand() % 9;
		if(cpu_start==1)
		{
			cpu_start=2;
			move=1;
			if (difficulty==0)
			{
				while(used[cpu_move] != 0)
				{
					cpu_move = rand() % 9;
				}
			}
			else if (difficulty==1)
			{
					if (user_move == 1) { // CPU goes first
							cpu_move = 8;	// Pick lower right corner
						}
						else if (user_move == 2) {
							if (user[0] == 1 || user[1] == 1 || user[3] == 1) { // First user move upper left, upper middle, or middle left
								cpu_move = 6;
							}
							else if (user[2] == 1 || user[4] == 1 || user[5] == 1) { // First user move upper right, middle, or middle right
								cpu_move = 7;
							}
							else if (user[6] == 1 || user[7] == 1) { // First user move lower left or lower middle
								cpu_move = 5;
							}
						}
						else if (user_move == 3) {
							// First - upper left, second - upper middle, upper right, middle left, middle, or middle right
							if (user[0] == 1 && (user[1] == 2 || user[2] == 2 || user[3] == 2 
											  || user[4] == 2 || user[5] == 2)) {	
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[7] == 2) {	// First - upper left, second - lower middle
								cpu_move = 2;
							}
							// First - upper middle, second - upper left, upper right, middle left, middle, or middle right
							else if (user[1] == 1 && (user[0] == 2 || user[2] == 2 || user[3] == 2 
												   || user[4] == 2 || user[5] == 2)) {	
								cpu_move = 7;
							}
							else if (user[1] == 1 && user[7] == 2) { // First -- upper middle, second - lower middle
								cpu_move = 4;
							}
							// First - upper right, second - upper left, upper middle, middle left, middle, or middle right
							else if (user[2] == 1 && (user[0] == 2 || user[1] == 2 || user[3] == 2 
												   || user[4] == 2 || user[5] == 2)) {	
								cpu_move = 6;
							}
							else if (user[2] == 1 && user[6] == 2) { // First - upper right, second - lower left
								cpu_move = 4;
							}
							// First - middle left, second - upper left, upper middle, upper right, middle, or middle right
							else if (user[3] == 1 && (user[0] == 2 || user[1] == 2 || user[2] == 2 
												   || user[4] == 2 || user[5] == 2)) {	
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[7] == 2) { // First - middle left, second - lower middle
								cpu_move = 4;
							}
							// First - middle, second - upper left, upper middle, upper right, middle left, or middle right
							else if (user[4] == 1 && (user[0] == 2 || user[1] == 2 || user[2] == 2 
												   || user[3] == 2 || user[5] == 2)) {	
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[6] == 2) { // First - middle, second - lower left
								cpu_move = 2;
							}
							// First - middle right, second - upper left, upper middle, upper right, middle left, or middle
							else if (user[5] == 1 && (user[0] == 2 || user[1] == 2 || user[2] == 2 
												   || user[3] == 2 || user[4] == 2)) {	
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[6] == 2) { // First - middle right, second - lower left
								cpu_move = 4;
							}
							// First - lower left, second - upper left, upper middle, middle left, middle, or lower middle
							else if (user[6] == 1 && (user[0] == 2 || user[1] == 2 || user[3] == 2 
												   || user[4] == 2 || user[7] == 2)) {	
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[2] == 2) { // First - lower left, second - upper right
								cpu_move = 4;
							}
							// First - lower middle, second - upper left, upper middle, middle left, middle, or lower left
							else if (user[7] == 1 && (user[0] == 2 || user[1] == 2 || user[3] == 2 
												   || user[4] == 2 || user[6] == 2)) {	
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[2] == 2) { // First - lower middle, second - upper right
								cpu_move = 4;
							}
						}
						else if (user_move == 4) {
							// First - upper left, second - lower middle, third - upper middle, middle left, or middle
							if (user[0] == 1 && user[7] == 2 && (user[1] == 3 || user[3] == 3 || user[4] == 3)) { 
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[7] == 2 && user[5] == 3) { // First - upper left, second - lower middle, third - middle right
								cpu_move = 4;
							}
							// First - upper middle, second - lower middle, third - upper left
							else if (user[1] == 1 && user[7] == 2 && (user[0] == 3 || user[3] == 3 || user[5] == 3)) { 
								cpu_move = 2;
							}
							else if (user[1] == 1 && user[7] == 2 && user[2] == 3) { // First - upper middle, second - lower middle, third - upper right
								cpu_move = 0;
							}
							// First - upper right, second - lower left, third - upper left, middle left, or middle right
							else if (user[2] == 1 && user[6] == 2 && (user[0] == 3 || user[3] == 3 || user[5] == 3)) { 
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[6] == 2 && user[1] == 3) { // First - upper right, second - lower left, third - upper middle
								cpu_move = 0;
							}
							// First - middle left, second - lower middle, third - upper left, upper middle, or middle right
							else if (user[3] == 1 && user[7] == 2 && (user[0] == 3 || user[1] == 3 || user[5] == 3)) { 
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[2] == 3) { // First - middle left, second - lower middle, third - upper right
								cpu_move = 0;
							}
							// First - middle, second - lower left, third - upper left, upper middle, middle left
							else if (user[4] == 1 && user[6] == 2 && (user[0] == 3 || user[1] == 3 || user[3] == 3)) { 
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[6] == 2 && user[5] == 3) { // First - middle, second - lower left, third - middle right
								cpu_move = 3;
							}
							// First - middle right, second - lower left, third - upper left, upper right, or middle left
							else if (user[5] == 1 && user[6] == 2 && (user[0] == 3 || user[2] == 3 || user[3] == 3)) { 
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[6] == 2 && user[1] == 3) { // First - middle right, second - lower left, third - upper middle
								cpu_move = 0;
							}
							// First - lower left, second - upper right, third - upper left, upper middle, or lower middle
							else if (user[6] == 1 && user[2] == 2 && (user[0] == 3 || user[1] == 3 || user[7] == 3)) { 
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[2] == 2 && user[3] == 3) { // First - lower left, second - upper right, third - middle left
								cpu_move = 0;
							}
							// First - lower middle, second - upper right, third - upper left, upper middle, or lower left
							else if (user[7] == 1 && user[2] == 2 && (user[0] == 3 || user[1] == 3 || user[6] == 3)) { 
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[2] == 2 && user[3] == 3) { // First - lower middle, second - upper right, third - middle left
								cpu_move = 0;
							}
						}
						else if (user_move == 5) {
							// First - middle, second - lower left, third - middle right, fourth - upper left
							if (user[4] == 1 && user[6] == 2 && user[5] == 3 && user[0] == 4) {
								cpu_move = 1;
							}
							// First - middle, second - lower left, third - middle right, fourth - upper middle
							else if (user[4] == 1 && user[6] == 2 && user[5] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
				}
			}
			used[cpu_move] =2;
			setTextSize(6);
			setTextColor(WHITE);
			if (cpu_move==0)
			{
				drawCircle(43,130,22,WHITE);
				drawCircle(43,130,23,WHITE);
				drawCircle(43,130,24,WHITE);
				drawCircle(43,130,25,WHITE);
			}
			else if (cpu_move==1)
			{
				drawCircle(123,130,22,WHITE);
				drawCircle(123,130,23,WHITE);
				drawCircle(123,130,24,WHITE);
				drawCircle(123,130,25,WHITE);
			}
			else if (cpu_move==2)
			{
				drawCircle(200,130,22,WHITE);
				drawCircle(200,130,23,WHITE);
				drawCircle(200,130,24,WHITE);
				drawCircle(200,130,25,WHITE);
			}
			else if (cpu_move==3)
			{
				drawCircle(43,207,22,WHITE);
				drawCircle(43,207,23,WHITE);
				drawCircle(43,207,24,WHITE);
				drawCircle(43,207,25,WHITE);
			}
			else if (cpu_move==4)
			{
				drawCircle(123,207,22,WHITE);
				drawCircle(123,207,23,WHITE);
				drawCircle(123,207,24,WHITE);
				drawCircle(123,207,25,WHITE);
			}
			else if (cpu_move==5)
			{
				drawCircle(200,207,22,WHITE);
				drawCircle(200,207,23,WHITE);
				drawCircle(200,207,24,WHITE);
				drawCircle(200,207,25,WHITE);
			}
			else if (cpu_move==6)
			{
				drawCircle(43,283,22,WHITE);
				drawCircle(43,283,23,WHITE);
				drawCircle(43,283,24,WHITE);
				drawCircle(43,283,25,WHITE);
			}
			else if (cpu_move==7)
			{
				drawCircle(123,283,22,WHITE);
				drawCircle(123,283,23,WHITE);
				drawCircle(123,283,24,WHITE);
				drawCircle(123,283,25,WHITE);
			}
			else if (cpu_move==8)
			{
				drawCircle(200,283,22,WHITE);
				drawCircle(200,283,23,WHITE);
				drawCircle(200,283,24,WHITE);
				drawCircle(200,283,25,WHITE);
			}
			if (used[0]==2 && used[1]==2 && used[2]==2)
					{
						drawLine(0,130,240,130,WHITE);
						drawLine(0,131,240,131,WHITE);
						drawLine(0,132,240,132,WHITE);
						drawLine(0,133,240,133,WHITE);
						win=2;
					}
					else if (used[3]==2 && used[4]==2 && used[5]==2)
					{
						drawLine(0,210,240,210,WHITE);
						drawLine(0,211,240,211,WHITE);
						drawLine(0,212,240,212,WHITE);
						drawLine(0,213,240,213,WHITE);
						win=2;
					}
					else if (used[6]==2 && used[7]==2 && used[8]==2)
					{
						drawLine(0,285,240,285,WHITE);
						drawLine(0,286,240,286,WHITE);
						drawLine(0,287,240,287,WHITE);
						drawLine(0,288,240,288,WHITE);
						win=2;
					}
					else if (used[0]==2 && used[3]==2 && used[6]==2)
					{
						drawLine(40,100,40,320,WHITE);
						drawLine(41,100,41,320,WHITE);
						drawLine(42,100,42,320,WHITE);
						drawLine(43,100,43,320,WHITE);
						win=2;
					}
					else if (used[1]==2 && used[4]==2 && used[7]==2)
					{
						drawLine(120,100,120,320,WHITE);
						drawLine(121,100,121,320,WHITE);
						drawLine(122,100,122,320,WHITE);
						drawLine(123,100,123,320,WHITE);
						win=2;
					}
					else if (used[2]==2 && used[5]==2 && used[8]==2)
					{
						drawLine(200,100,200,320,WHITE);
						drawLine(201,100,201,320,WHITE);
						drawLine(202,100,202,320,WHITE);
						drawLine(203,100,203,320,WHITE);
						win=2;
					}
					else if (used[0]==2 && used[4]==2 && used[8]==2)
					{
						drawLine(2,102,238,320,WHITE);
						drawLine(1,101,239,320,WHITE);
						drawLine(0,100,240,320,WHITE);
						drawLine(1,101,240,319,WHITE);
						drawLine(2,102,240,318,WHITE);
						win=2;
					}
					else if (used[2]==2 && used[4]==2 && used[6]==2)
					{
						drawLine(238,102,2,318,WHITE);
						drawLine(239,101,1,319,WHITE);
						drawLine(240,100,0,320,WHITE);
						drawLine(240,101,1,320,WHITE);
						drawLine(240,102,2,320,WHITE);
						win=2;
					}
					if (win==0)
				{
					if (used[0] !=0 && used[1] !=0 && used[2] !=0 && used[3] !=0 && used[4] !=0 && used[5] !=0 && 
						used[6] !=0 && used[7] !=0 && used[8] !=0)
						{
							win=3;
						}
				}
				if (win!=0)
				{
					user_move=1;
					if (cpu_start==0)
					{
						cpu_start=1;
					}
					else
					{
						cpu_start=0;
					}
					if (win!=3)
					{
						_delay_ms(2000);
					}
					fillRect(0,100,79,70,BLACK);
					fillRect(83,100,78,70,BLACK);
					fillRect(164,100,80,70,BLACK);
					fillRect(0,174,79,70,BLACK);
					fillRect(83,174,78,70,BLACK);
					fillRect(164,174,80,70,BLACK);
					fillRect(0,247,79,75,BLACK);
					fillRect(83,247,78,75,BLACK);
					fillRect(164,247,80,75,BLACK);
					drawLine(79,100,79,316,BLUE);
					drawLine(80,100,80,316,BLUE);
					drawLine(81,100,81,316,BLUE);
					drawLine(82,100,82,316,BLUE);
					drawLine(160,100,160,316,BLUE);
					drawLine(161,100,161,316,BLUE);
					drawLine(162,100,162,316,BLUE);
					drawLine(163,100,163,316,BLUE);
					drawLine(10,170,230,170,BLUE);
					drawLine(10,171,230,171,BLUE);
					drawLine(10,172,230,172,BLUE);
					drawLine(10,173,230,173,BLUE);
					drawLine(10,244,230,244,BLUE);
					drawLine(10,245,230,245,BLUE);
					drawLine(10,246,230,246,BLUE);
					drawLine(10,247,230,247,BLUE);
					for (int i=0; i<9;i++)
					{
						used[i]=0;
						user[i]=0;
					}
					touched=0;
					touch_index=0;
					move=0;
					if(win==1)
					{
						player++;
						sprintf(buff,"%d\n",player);
						fillRect(0,25,60,35,BLACK);
						setTextSize(4);
						setTextColor(WHITE);
						if(player>10)
						{
							setCursor(15,25);
						}
						else
						{
							setCursor(25,25);
						}
						drawString(buff);
					}
					else if (win==2)
					{
						cpu++;
						sprintf(buff,"%d\n",cpu);
						fillRect(190,25,60,35,BLACK);
						setTextSize(4);
						setTextColor(WHITE);
						if(cpu>10)
						{
							setCursor(187,25);
						}
						else
						{
							setCursor(197,25);
						}
						drawString(buff);
					}
					else if (win==3)
					{
						tie++;
						sprintf(buff,"%d\n",tie);
						fillRect(105,25,60,35,BLACK);
						setTextSize(4);
						setTextColor(WHITE);
						if(tie>10)
						{
							setCursor(102,25);
						}
						else
						{
							setCursor(112,25);
						}
						drawString(buff);
					}
					win=0;
				}
		}
		x= readTouchX();
		y=readTouchY();
		yy=y;
		z=pressure();
		x=map(x,TS_MINX, TS_MAXX, TFTWIDTH, 0);
		y=map(y,TS_MINY, TS_MAXY, TFTHEIGHT, 0);
		if (yy>TS_MAXX+10)
		{
			return;
		}
		else if (z>300 && z<800)
		{
			if(y>65 && y<95)
			{
				if (x>20 && x<110 && difficulty==1)
				{
					difficulty=0;
					drawRect(20, 65, 90, 30, BLUE);
					drawRect(20+1, 65+1, 90-2, 30-2, BLUE);
					drawRect(20+2, 65+2, 90-3, 30-3, BLUE);
					drawRect(130, 65, 90, 30, GREY);
					drawRect(130+1, 65+1, 90-2, 30-2, GREY);
					drawRect(130+2, 65+2, 90-3, 30-3, GREY);
				}
				else if (x>130 && x<220 && difficulty==0)
				{
					difficulty=1;
					drawRect(130, 65, 90, 30, BLUE);
					drawRect(130+1, 65+1, 90-2, 30-2, BLUE);
					drawRect(130+2, 65+2, 90-3, 30-3, BLUE);
					drawRect(20, 65, 90, 30, GREY);
					drawRect(20+1, 65+1, 90-2, 30-2, GREY);
					drawRect(20+2, 65+2, 90-3, 30-3, GREY);
				}
			}
			else if (y>100 && y<170)
			{
				if (x<79 && used[0]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=0;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=0;
					}
				}
				else if (x>83 && x<160 && used[1]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=1;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=1;
					}
				}
				else if (x>164 && used[2]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=2;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=2;
					}
				}
			}
			else if (y>174 && y<247)
			{
				if (x<79 && used[3]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=3;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=3;
					}
				}
				else if (x>83 && x<160 && used[4]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=4;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=4;
					}
				}
				else if (x>164 && used[5]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=5;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=5;
					}
				}
			}
			else if (y>251)
			{
				if (x<79 && used[6]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=6;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=6;
					}
				}
				else if (x>83 && x<160 && used[7]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=7;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=7;
					}
				}
				else if (x>164 && used[8]==0)
				{
					fillCircle(x, y, 2, WHITE);
					if (touched==0)
					{
						touched=1;
						touch_index=8;
					}
					else if (touched==2)
					{
						touched=3;
						touch_index=8;
					}
				}
			}
		}
		else
		{
			if(touched==1)
			{
				touched=2;
			}
			else if (touched==3)
			{
				used[touch_index]=1;
				user[touch_index]= user_move;
				user_move++;
				touched=0;
				move++;
				if (used[0]==1 && used[1]==1 && used[2]==1)
				{
					drawLine(0,130,240,130,WHITE);
					drawLine(0,131,240,131,WHITE);
					drawLine(0,132,240,132,WHITE);
					drawLine(0,133,240,133,WHITE);
					win=1;
				}
				else if (used[3]==1 && used[4]==1 && used[5]==1)
				{
					drawLine(0,210,240,210,WHITE);
					drawLine(0,211,240,211,WHITE);
					drawLine(0,212,240,212,WHITE);
					drawLine(0,213,240,213,WHITE);
					win=1;
				}
				else if (used[6]==1 && used[7]==1 && used[8]==1)
				{
					drawLine(0,285,240,285,WHITE);
					drawLine(0,286,240,286,WHITE);
					drawLine(0,287,240,287,WHITE);
					drawLine(0,288,240,288,WHITE);
					win=1;
				}
				else if (used[0]==1 && used[3]==1 && used[6]==1)
				{
					drawLine(40,100,40,320,WHITE);
					drawLine(41,100,41,320,WHITE);
					drawLine(42,100,42,320,WHITE);
					drawLine(43,100,43,320,WHITE);
					win=1;
				}
				else if (used[1]==1 && used[4]==1 && used[7]==1)
				{
					drawLine(120,100,120,320,WHITE);
					drawLine(121,100,121,320,WHITE);
					drawLine(122,100,122,320,WHITE);
					drawLine(123,100,123,320,WHITE);
					win=1;
				}
				else if (used[2]==1 && used[5]==1 && used[8]==1)
				{
					drawLine(200,100,200,320,WHITE);
					drawLine(201,100,201,320,WHITE);
					drawLine(202,100,202,320,WHITE);
					drawLine(203,100,203,320,WHITE);
					win=1;
				}
				else if (used[0]==1 && used[4]==1 && used[8]==1)
				{
					drawLine(2,102,238,320,WHITE);
					drawLine(1,101,239,320,WHITE);
					drawLine(0,100,240,320,WHITE);
					drawLine(1,101,240,319,WHITE);
					drawLine(2,102,240,318,WHITE);
					win=1;
				}
				else if (used[2]==1 && used[4]==1 && used[6]==1)
				{
					drawLine(238,102,2,318,WHITE);
					drawLine(239,101,1,319,WHITE);
					drawLine(240,100,0,320,WHITE);
					drawLine(240,101,1,320,WHITE);
					drawLine(240,102,2,320,WHITE);
					win=1;
				}
				if (win==0)
				{
					if (used[0] !=0 && used[1] !=0 && used[2] !=0 && used[3] !=0 && used[4] !=0 && used[5] !=0 && 
						used[6] !=0 && used[7] !=0 && used[8] !=0)
						{
							win=3;
						}
				}
				if (win!=1 && win!=3 && cpu_start==0)
				{
					if (difficulty==0)
					{
						//Check horizontal win
						if (used[0]==2 && used[1] == 2 && used[2] ==0)
						{
							cpu_move=2;
						}
						else if (used[0]==2 && used[1] == 0 && used[2] ==2)
						{
							cpu_move=1;
						}
						else if (used[0]==0 && used[1] == 2 && used[2] ==2)
						{
							cpu_move=0;
						}
						else if (used[3]==2 && used[4] == 2 && used[5] == 0)
						{
							cpu_move=5;
						}
						else if (used[3]==2 && used[4] == 0 && used[5] == 2)
						{
							cpu_move=4;
						}
						else if (used[3]==0 && used[4] == 2 && used[5] == 2)
						{
							cpu_move=3;
						}
						else if (used[6]==2 && used[7] == 2 && used[8] == 0)
						{
							cpu_move=8;
						}
						else if (used[6]==2 && used[7] == 0 && used[8] == 2)
						{
							cpu_move=7;
						}
						else if (used[6]==0 && used[7] == 2 && used[8] == 2)
						{
							cpu_move=6;
						}
						//Check vertical win
						else if (used[0]==2 && used[3] == 2 && used[6] == 0)
						{
							cpu_move=6;
						}
						else if (used[0]==2 && used[3] == 0 && used[6] == 2)
						{
							cpu_move=3;
						}
						else if (used[0]==0 && used[3] == 2 && used[6] == 2)
						{
							cpu_move=0;
						}
						else if (used[1]==2 && used[4] == 2 && used[7] == 0)
						{
							cpu_move=7;
						}
						else if (used[1]==2 && used[4] == 0 && used[7] == 2)
						{
							cpu_move=4;
						}
						else if (used[1]==0 && used[4] == 2 && used[7] == 2)
						{
							cpu_move=1;
						}
						else if (used[2]==2 && used[5] == 2 && used[8] == 0)
						{
							cpu_move=8;
						}
						else if (used[2]==2 && used[5] == 0 && used[8] == 2)
						{
							cpu_move=5;
						}
						else if (used[2]==0 && used[5] == 2 && used[8] == 2)
						{
							cpu_move=2;
						}
						//Check for diagonal win
						else if (used[0]==2 && used[4] == 2 && used[8] == 0)
						{
							cpu_move=8;
						}
						else if (used[0]==2 && used[4] == 0 && used[8] == 2)
						{
							cpu_move=4;
						}
						else if (used[0]==0 && used[4] == 2 && used[8] == 2)
						{
							cpu_move=0;
						}
						else if (used[2]==2 && used[4] == 2 && used[6] == 0)
						{
							cpu_move=6;
						}
						else if (used[2]==2 && used[4] == 0 && used[6] == 2)
						{
							cpu_move=4;
						}
						else if (used[2]==0 && used[4] == 2 && used[6] == 2)
						{
							cpu_move=2;
						}
						//Check for horizontal block
						else if (used[0]==1 && used[1] == 1 && used[2] ==0)
						{
							cpu_move=2;
						}
						else if (used[0]==1 && used[1] == 0 && used[2] ==1)
						{
							cpu_move=1;
						}
						else if (used[0]==0 && used[1] == 1 && used[2] ==1)
						{
							cpu_move=0;
						}
						else if (used[3]==1 && used[4] == 1 && used[5] == 0)
						{
							cpu_move=5;
						}
						else if (used[3]==1 && used[4] == 0 && used[5] == 1)
						{
							cpu_move=4;
						}
						else if (used[3]==0 && used[4] == 1 && used[5] == 1)
						{
							cpu_move=3;
						}
						else if (used[6]==1 && used[7] == 1 && used[8] == 0)
						{
							cpu_move=8;
						}
						else if (used[6]==1 && used[7] == 0 && used[8] == 1)
						{
							cpu_move=7;
						}
						else if (used[6]==0 && used[7] == 1 && used[8] == 1)
						{
							cpu_move=6;
						}
						//Check vertical block
						else if (used[0]==1 && used[3] == 1 && used[6] == 0)
						{
							cpu_move=6;
						}
						else if (used[0]==1 && used[3] == 0 && used[6] == 1)
						{
							cpu_move=3;
						}
						else if (used[0]==0 && used[3] == 1 && used[6] == 1)
						{
							cpu_move=0;
						}
						else if (used[1]==1 && used[4] == 1 && used[7] == 0)
						{
							cpu_move=7;
						}
						else if (used[1]==1 && used[4] == 0 && used[7] == 1)
						{
							cpu_move=4;
						}
						else if (used[1]==0 && used[4] == 1 && used[7] == 1)
						{
							cpu_move=1;
						}
						else if (used[2]==1 && used[5] == 1 && used[8] == 0)
						{
							cpu_move=8;
						}
						else if (used[2]==1 && used[5] == 0 && used[8] == 1)
						{
							cpu_move=5;
						}
						else if (used[2]==0 && used[5] == 1 && used[8] == 1)
						{
							cpu_move=2;
						}
						//Check for diagonal block
						else if (used[0]==1 && used[4] == 1 && used[8] == 0)
						{
							cpu_move=8;
						}
						else if (used[0]==1 && used[4] == 0 && used[8] == 1)
						{
							cpu_move=4;
						}
						else if (used[0]==0 && used[4] == 1 && used[8] == 1)
						{
							cpu_move=0;
						}
						else if (used[2]==1 && used[4] == 1 && used[6] == 0)
						{
							cpu_move=6;
						}
						else if (used[2]==1 && used[4] == 0 && used[6] == 1)
						{
							cpu_move=4;
						}
						else if (used[2]==0 && used[4] == 1 && used[6] == 1)
						{
							cpu_move=2;
						}
						else
						{
							if (move==1)
							{
								if (used[0] ==1 || used[2]==1 || used[6]==1 || used[8]==1)
								{
									cpu_move=4;
								}
								else if (used[4]==1)
								{
									cpu_move = rand() %4;
									if (cpu_move==1)
									{
										cpu_move=2;
									}
									else if (cpu_move==2)
									{
									cpu_move=6;
									}
									else if (cpu_move==3)
									{
										cpu_move=8;
									}
								}
							}
							else {
								while(used[cpu_move] != 0)
								{
									cpu_move = rand() % 9;
								}
							}
						}
					}
					else if (difficulty==1)
					{
						// Add Hard AI here
						// User has gone first
						sum = sum_used(used);
						if (user_move == 2) { // First move for CPU
							if (user[0] == 1) { // User in upper left corner
								cpu_move = 4;
							}
							else if (user[1] == 1) { // User in upper middle
								cpu_move = 7;
							}
							else if (user[2] == 1) { // User in upper right
								cpu_move = 4;
							}
							else if (user[3] == 1) { // User in middle left
								cpu_move = 6;
							}
							else if (user[4] == 1) { // User in middle
								cpu_move = 8;
							}
							else if (user[5] == 1) { // User in middle right
								cpu_move = 8;
							}
							else if (user[6] == 1) { // User in lower left
								cpu_move = 4;
							}
							else if (user[7] == 1) { // User in lower middle
								cpu_move = 8;
							}
							else if (user[8] == 1) { // User in lower right
								cpu_move = 4;
							}
						}
						else if (user_move == 3) { // Second move for CPU
							if (user[0] == 1 && user[1] == 2) { // First user move in upper left
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[2] == 2) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[3] == 2) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[5] == 2) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[7] == 2) {
								cpu_move = 8;
							}
							else if (user[0] == 1 && user[8] == 2) {
								cpu_move = 7;
							}
							else if (user[1] == 1 && user[0] == 2) { // First user move in upper middle
								cpu_move = 2;
							}
							else if (user[1] == 1 && user[2] == 2) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[3] == 2) {
								cpu_move = 2;
							}
							else if (user[1] == 1 && user[4] == 2) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[5] == 2) {
								cpu_move = 2;
							}
							else if (user[1] == 1 && user[6] == 2) {
								cpu_move = 2;
							}
							else if (user[1] == 1 && user[8] == 2) {
								cpu_move = 2;
							}
							else if (user[2] == 1 && user[0] == 2) { // First user move in upper right
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[1] == 2) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[3] == 2) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[5] == 2) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[6] == 2) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[7] == 2) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[8] == 2) {
								cpu_move = 5;
							}
							else if (user[3] == 1 && user[0] == 2) { // First user move in middle left
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[1] == 2) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[2] == 2) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2) {
								cpu_move = 5;
							}
							else if (user[3] == 1 && user[5] == 2) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[7] == 2) {
								cpu_move = 5;
							}
							else if (user[3] == 1 && user[8] == 2) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[0] == 2) { // First user move in middle
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[1] == 2) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[2] == 2) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[3] == 2) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[5] == 2) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[6] == 2) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[7] == 2) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[0] == 2) { // First user move in middle right
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[1] == 2) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[2] == 2) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[3] == 2) {
								cpu_move = 4;
							}
							else if (user[5] == 1 && user[4] == 2) {
								cpu_move = 3;
							}
							else if (user[5] == 1 && user[6] == 2) {
								cpu_move = 4;
							}
							else if (user[5] == 1 && user[7] == 2) {
								cpu_move = 4;
							}
							else if (user[6] == 1 && user[0] == 2) { // First user move in lower left
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[1] == 2) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[2] == 2) {
								cpu_move = 7;
							}
							else if (user[6] == 1 && user[3] == 2) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[5] == 2) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[7] == 2) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[8] == 2) {
								cpu_move = 7;
							}
							else if (user[7] == 1 && user[0] == 2) { // First user move in lower middle
								cpu_move = 4;
							}
							else if (user[7] == 1 && user[1] == 2) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[2] == 2) {
								cpu_move = 4;
							}
							else if (user[7] == 1 && user[3] == 2) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[4] == 2) {
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[5] == 2) {
								cpu_move = 4;
							}
							else if (user[7] == 1 && user[6] == 2) {
								cpu_move = 5;
							}
							else if (user[8] == 1 && user[0] == 2) { // First user move in lower right
								cpu_move = 7;
							}
							else if (user[8] == 1 && user[1] == 2) {
								cpu_move = 5;
							}
							else if (user[8] == 1 && user[2] == 2) {
								cpu_move = 5;
							}
							else if (user[8] == 1 && user[3] == 2) {
								cpu_move = 7;
							}
							else if (user[8] == 1 && user[5] == 2) {
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[6] == 2) {
								cpu_move = 7;
							}
							else if (user[8] == 1 && user[7] == 2) {
								cpu_move = 6;
							}
						}
						else if (user_move == 4) { // Third move for CPU
							if (user[0] == 1 && user[1] == 2 && user[3] == 3) { // First move upper left, second move upper middle
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[1] == 2 && user[5] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[1] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[1] == 2 && user[7] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[1] == 2 && user[8] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[2] == 2 && user[3] == 3) { // First move upper left, second move upper right
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[2] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[2] == 2 && user[6] == 3) {
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[2] == 2 && user[7] == 3) {
								cpu_move = 8;
							}
							else if (user[0] == 1 && user[2] == 2 && user[8] == 3) {
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[3] == 2 && user[1] == 3) { // First move upper left, second move middle left
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[3] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[3] == 2 && user[5] == 3) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[3] == 2 && user[7] == 3) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[3] == 2 && user[8] == 3) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[5] == 2 && user[1] == 3) { // First move upper left, second move middle right
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[5] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[5] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[5] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[5] == 2 && user[7] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[6] == 2 && user[1] == 3) { // First move upper left, second move lower left
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2 && user[2] == 3) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3) {
								cpu_move = 8;
							}
							else if (user[0] == 1 && user[6] == 2 && user[7] == 3) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2 && user[8] == 3) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[7] == 2 && user[1] == 3) { // First move upper left, second move lower middle
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[7] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[7] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[7] == 2 && user[5] == 3) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[7] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[8] == 2 && user[1] == 3) { // First move upper left, second move lower right
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[8] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[8] == 2 && user[3] == 3) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[8] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[8] == 2 && user[6] == 3) {
								cpu_move = 1;
							}
							else if (user[1] == 1 && user[0] == 2 && user[3] == 3) { // First move upper middle, second move upper left
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[0] == 2 && user[4] == 3) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[0] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[0] == 2 && user[8] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[2] == 2 && user[3] == 3) { // First move upper middle, second move upper right
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[2] == 2 && user[4] == 3) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[5] == 3) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[2] == 2 && user[6] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[2] == 2 && user[8] == 3) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[3] == 2 && user[0] == 3) { // First move upper middle, second move middle left
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[3] == 2 && user[4] == 3) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[3] == 2 && user[5] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[3] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[3] == 2 && user[8] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[4] == 2 && user[0] == 3) { // First move upper middle, second move middle
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[4] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[4] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[4] == 2 && user[5] == 3) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[4] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[1] == 1 && user[5] == 2 && user[0] == 3) { // First move upper middle, second move middle right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[5] == 2 && user[3] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[5] == 2 && user[4] == 3) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[5] == 2 && user[6] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[5] == 2 && user[8] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[6] == 2 && user[0] == 3) { // First move upper middle, second move lower left
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[6] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[6] == 2 && user[4] == 3) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[6] == 2 && user[5] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[6] == 2 && user[8] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[8] == 2 && user[0] == 3) { // First move upper middle, second move lower right
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[8] == 2 && user[3] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[8] == 2 && user[4] == 3) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[8] == 2 && user[5] == 3) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[8] == 2 && user[6] == 3) {
								cpu_move = 4;
							}
							else if (user[2] == 1 && user[0] == 2 && user[3] == 3) { // First move upper right, second move upper left
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[0] == 2 && user[6] == 3) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[0] == 2 && user[7] == 3) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[0] == 2 && user[8] == 3) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[1] == 2 && user[3] == 3) { // First move upper right, second move upper middle
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[1] == 2 && user[5] == 3) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[1] == 2 && user[6] == 3) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[1] == 2 && user[7] == 3) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[1] == 2 && user[8] == 3) {
								cpu_move = 5;
							}
							else if (user[2] == 1 && user[3] == 2 && user[0] == 3) { // First move upper right, second move middle left
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[3] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[3] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[3] == 2 && user[6] == 3) {
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[3] == 2 && user[8] == 3) {
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[5] == 2 && user[0] == 3) { // First move upper right, second move middle right
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[5] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[5] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[5] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[5] == 2 && user[7] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[6] == 2 && user[0] == 3) { // First move upper right, second move lower left
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[6] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[6] == 2 && user[3] == 3) {
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[6] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[6] == 2 && user[8] == 3) {
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[7] == 2 && user[0] == 3) { // First move upper right, second move lower middle
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[7] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[7] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[7] == 2 && user[5] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[7] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[8] == 2 && user[0] == 3) { // First move upper right, second move lower right
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[8] == 2 && user[1] == 3) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[8] == 2 && user[3] == 3) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[8] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[8] == 2 && user[7] == 3) {
								cpu_move = 3;
							}
							else if (user[3] == 1 && user[0] == 2 && user[1] == 3) { // First move middle left, second move upper left
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[0] == 2 && user[2] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[0] == 2 && user[4] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[0] == 2 && user[7] == 3) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[1] == 2 && user[0] == 3) { // First move middle left, second move upper middle
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[1] == 2 && user[2] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[1] == 2 && user[4] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[1] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[1] == 2 && user[7] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[2] == 2 && user[0] == 3) { // First move middle left, second move upper right
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[2] == 2 && user[1] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[2] == 2 && user[4] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[2] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[2] == 2 && user[7] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[4] == 2 && user[0] == 3) { // First move middle left, second move middle
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2 && user[1] == 3) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[2] == 3) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2 && user[7] == 3) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[4] == 2 && user[8] == 3) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[5] == 2 && user[0] == 3) { // First move middle left, second move middle right
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[5] == 2 && user[1] == 3) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[5] == 2 && user[2] == 3) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[5] == 2 && user[7] == 3) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[5] == 2 && user[8] == 3) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[0] == 3) { // First move middle left, second move lower middle
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[1] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[7] == 2 && user[2] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[7] == 2 && user[4] == 3) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[8] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[8] == 2 && user[0] == 3) { // First move middle left, second move lower right
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[8] == 2 && user[1] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[8] == 2 && user[2] == 3) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[8] == 2 && user[4] == 3) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[8] == 2 && user[7] == 3) {
								cpu_move = 4;
							}
							else if (user[4] == 1 && user[0] == 2 && user[1] == 3) { // First move middle, second move upper left
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[0] == 2 && user[2] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[0] == 2 && user[3] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[0] == 2 && user[7] == 3) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[1] == 2 && user[0] == 3) { // First move middle, second move upper middle
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[1] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[1] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[1] == 2 && user[5] == 3) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[1] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[2] == 2 && user[0] == 3) { // First move middle, second move upper right
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[2] == 2 && user[1] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[2] == 2 && user[3] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[2] == 2 && user[5] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[2] == 2 && user[7] == 3) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[3] == 2 && user[0] == 3) { // First move middle, second move middle left
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[3] == 2 && user[1] == 3) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[3] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[3] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[3] == 2 && user[7] == 3) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[5] == 2 && user[0] == 3) { // First move middle, second move middle right
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[5] == 2 && user[1] == 3) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[5] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[5] == 2 && user[7] == 3) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[6] == 2 && user[0] == 3) { // First move middle, second move lower left
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[6] == 2 && user[1] == 3) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[6] == 2 && user[3] == 3) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[6] == 2 && user[5] == 3) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[6] == 2 && user[7] == 3) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[0] == 3) { // First move middle, second move lower middle
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[7] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[7] == 2 && user[3] == 3) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[5] == 3) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[7] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[0] == 2 && user[1] == 3) { // First move middle right, second move upper left
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[0] == 2 && user[2] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[0] == 2 && user[3] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[0] == 2 && user[4] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[0] == 2 && user[7] == 3) {
								cpu_move = 4;
							}
							else if (user[5] == 1 && user[1] == 2 && user[0] == 3) { // First move middle right, second move upper middle
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[1] == 2 && user[2] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[1] == 2 && user[3] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[1] == 2 && user[4] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[1] == 2 && user[7] == 3) {
								cpu_move = 4;
							}
							else if (user[5] == 1 && user[2] == 2 && user[0] == 3) { // First move middle right, second move upper right
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[2] == 2 && user[1] == 3) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[2] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[2] == 2 && user[4] == 3) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[2] == 2 && user[6] == 3) {
								cpu_move = 4;
							}
							else if (user[5] == 1 && user[3] == 2 && user[0] == 3) { // First move middle right, second move middle left
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[3] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[3] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[3] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[3] == 2 && user[7] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[4] == 2 && user[0] == 3) { // First move middle right, second move middle
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[4] == 2 && user[1] == 3) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[4] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[4] == 2 && user[7] == 3) {
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[6] == 2 && user[0] == 3) { // First move middle right, second move lower left
								cpu_move = 3;
							}
							else if (user[5] == 1 && user[6] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[6] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[6] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[6] == 2 && user[7] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[7] == 2 && user[0] == 3) { // First move middle right, second move lower middle
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[7] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[7] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[7] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[7] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[0] == 2 && user[1] == 3) { // First move lower left, second move upper left
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[0] == 2 && user[2] == 3) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[0] == 2 && user[7] == 3) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[0] == 2 && user[8] == 3) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[1] == 2 && user[0] == 3) { // First move lower left, second move upper middle
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[1] == 2 && user[2] == 3) {
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[1] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[1] == 2 && user[7] == 3) {
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[1] == 2 && user[8] == 3) {
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[2] == 2 && user[0] == 3) { // First move lower left, second move upper right
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[2] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[2] == 2 && user[3] == 3) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[2] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[2] == 2 && user[8] == 3) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[3] == 2 && user[1] == 3) { // First move lower left, second move middle left
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[3] == 2 && user[2] == 3) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[3] == 2 && user[5] == 3) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[3] == 2 && user[7] == 3) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[3] == 2 && user[8] == 3) {
								cpu_move = 7;
							}
							else if (user[6] == 1 && user[5] == 2 && user[0] == 3) { // First move lower left, second move middle right
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[5] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[5] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[5] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[5] == 2 && user[7] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[7] == 2 && user[0] == 3) { // First move lower left, second move lower middle
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[7] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[7] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[7] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[7] == 2 && user[5] == 3) {
								cpu_move = 0;
							}
							else if (user[6] == 1 && user[8] == 2 && user[0] == 3) { // First move lower left, second move lower right
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[8] == 2 && user[1] == 3) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[8] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[8] == 2 && user[3] == 3) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[8] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[0] == 2 && user[1] == 3) { // First move lower middle, second move upper left
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[0] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[0] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[0] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[1] == 2 && user[0] == 3) { // First move lower middle, second move upper middle
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[1] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[1] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[1] == 2 && user[5] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[1] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[2] == 2 && user[0] == 3) { // First move lower middle, second move upper right
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[2] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[2] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[2] == 2 && user[5] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[2] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[3] == 2 && user[0] == 3) { // First move lower middle, second move middle left
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[3] == 2 && user[1] == 3) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[3] == 2 && user[4] == 3) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[3] == 2 && user[5] == 3) {
								cpu_move = 4;
							}
							else if (user[7] == 1 && user[3] == 2 && user[6] == 3) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[0] == 3) { // First move lower middle, second move middle
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[4] == 2 && user[2] == 3) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[4] == 2 && user[3] == 3) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[5] == 3) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[4] == 2 && user[6] == 3) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[5] == 2 && user[0] == 3) { // First move lower middle, second move middle right
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[5] == 2 && user[1] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[5] == 2 && user[2] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[5] == 2 && user[3] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[5] == 2 && user[6] == 3) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[6] == 2 && user[0] == 3) { // First move lower middle, second move lower left
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[6] == 2 && user[1] == 3) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[6] == 2 && user[2] == 3) {
								cpu_move = 4;
							}
							else if (user[7] == 1 && user[6] == 2 && user[3] == 3) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[6] == 2 && user[4] == 3) {
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[0] == 2 && user[1] == 3) { // First move lower right, second move upper left
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[0] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[0] == 2 && user[3] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[0] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[0] == 2 && user[6] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[1] == 2 && user[0] == 3) { // First move lower right, second move upper middle
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[1] == 2 && user[2] == 3) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[1] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[1] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[1] == 2 && user[7] == 3) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[2] == 2 && user[0] == 3) { // First move lower right, second move upper right
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[2] == 2 && user[1] == 3) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[2] == 2 && user[3] == 3) {
								cpu_move = 7;
							}
							else if (user[8] == 1 && user[2] == 2 && user[6] == 3) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[2] == 2 && user[7] == 3) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[3] == 2 && user[0] == 3) { // First move lower right, second move middle left
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[3] == 2 && user[1] == 3) {
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[3] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[3] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[3] == 2 && user[6] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[5] == 2 && user[0] == 3) { // First move lower right, second move middle right
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[5] == 2 && user[1] == 3) {
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[5] == 2 && user[3] == 3) {
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[5] == 2 && user[6] == 3) {
								cpu_move = 7;
							}
							else if (user[8] == 1 && user[5] == 2 && user[7] == 3) {
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[6] == 2 && user[0] == 3) { // First move lower right, second move lower left
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[6] == 2 && user[1] == 3) {
								cpu_move = 5;
							}
							else if (user[8] == 1 && user[6] == 2 && user[2] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[6] == 2 && user[3] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[6] == 2 && user[5] == 3) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[7] == 2 && user[0] == 3) { // First move lower right, second move lower middle
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[7] == 2 && user[1] == 3) {
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[7] == 2 && user[2] == 3) {
								cpu_move = 5;
							}
							else if (user[8] == 1 && user[7] == 2 && user[3] == 3) {
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[7] == 2 && user[5] == 3) {
								cpu_move = 2;
							}
						}
						else if (user_move == 5) { // Fourth move for CPU
							if (user[0] == 1 && user[1] == 2 && user[6] == 3 && user[5] == 4) { // First - upper left, second - upper middle, third - lower left
								cpu_move = 8;
							}
							else if (user[0] == 1 && user[1] == 2 && user[6] == 3 && user[7] == 4) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[1] == 2 && user[6] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[2] == 2 && user[7] == 3 && user[3] == 4) { // First - upper left, second - upper right, third - lower middle
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[2] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[2] == 2 && user[7] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[3] == 2 && user[2] == 3 && user[5] == 4) { // First - upper left, second - middle left, third - upper right
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[3] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 8;
							}
							else if (user[0] == 1 && user[3] == 2 && user[2] == 3 && user[8] == 4) {
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[5] == 2 && user[1] == 3 && user[3] == 4) { // First - upper left, second - middle right, third - upper middle
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[5] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[5] == 2 && user[1] == 3 && user[7] == 4) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[5] == 2 && user[2] == 3 && user[3] == 4) { // First - upper left, second - middle right, third - upper right
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[5] == 2 && user[2] == 3 && user[6] == 4) {
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[5] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[5] == 2 && user[3] == 3 && user[1] == 4) { // First - upper left, second - middle right, third - middle left
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[5] == 2 && user[3] == 3 && user[2] == 4) {
								cpu_move = 7;
							}
							else if (user[0] == 1 && user[5] == 2 && user[3] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[5] == 2 && user[6] == 3 && user[1] == 4) { // First - upper left, second - middle right, third - lower left
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[5] == 2 && user[6] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[5] == 2 && user[6] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[5] == 2 && user[7] == 3 && user[1] == 4) { // First - upper left, second - middle right, third - lower middle
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[5] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[5] == 2 && user[7] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3 && user[1] == 4) { // First - upper left, second - lower left, third - middle right
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[1] == 3 && user[3] == 4) { // First - upper left, second - lower middle, third - upper middle
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[6] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[6] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2 && user[2] == 3 && user[3] == 4) { // First - upper left, second - lower middle, third - upper right
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[6] == 2 && user[2] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[6] == 2 && user[2] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[0] == 1 && user[6] == 2 && user[3] == 3 && user[1] == 4) { // First - upper left, second - lower middle, third - middle left
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[3] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[6] == 2 && user[3] == 3 && user[5] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3 && user[1] == 4) { // First - upper left, second - lower middle, third - middle right
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[0] == 1 && user[6] == 2 && user[5] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[6] == 2 && user[6] == 3 && user[1] == 4) { // First - upper left, second - lower middle, third - lower left
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2 && user[6] == 3 && user[2] == 4) {
								cpu_move = 5;
							}
							else if (user[0] == 1 && user[6] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 2;
							}
							else if (user[0] == 1 && user[8] == 2 && user[1] == 3 && user[3] == 4) { // First - upper left, second - lower right, third - upper middle
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[8] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[0] == 1 && user[8] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[0] == 2 && user[3] == 3 && user[4] == 4) { // First - upper middle, second - upper left, third - middle left
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[3] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[3] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[0] == 2 && user[4] == 3 && user[3] == 4) { // First - upper middle, second - upper left, third - middle
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[0] == 2 && user[4] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[0] == 2 && user[4] == 3 && user[6] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[0] == 2 && user[5] == 3 && user[3] == 4) { // First - upper middle, second - upper left, third - middle right
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[5] == 3 && user[4] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[5] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[0] == 2 && user[6] == 3 && user[4] == 4) { // First - upper middle, second - upper left, third - lower left
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[0] == 2 && user[6] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[0] == 2 && user[8] == 3 && user[3] == 4) { // First - upper middle, second - upper left, third - lower right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[0] == 2 && user[8] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[0] == 2 && user[8] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[2] == 2 && user[3] == 3 && user[4] == 4) { // First - upper middle, second - upper right, third - middle left
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[3] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[2] == 2 && user[4] == 3 && user[3] == 4) { // First - upper middle, second - upper right, third - middle
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[2] == 2 && user[4] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[2] == 2 && user[4] == 3 && user[8] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[2] == 2 && user[5] == 3 && user[3] == 4) { // First - upper middle, second - upper right, third - middle right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[5] == 3 && user[4] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[5] == 3 && user[6] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[2] == 2 && user[6] == 3 && user[3] == 4) { // First - upper middle, second - upper right, third - lower left
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[2] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[2] == 2 && user[6] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[2] == 2 && user[8] == 3 && user[3] == 4) { // First - upper middle, second - upper right, third - lower right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[8] == 3 && user[4] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[2] == 2 && user[8] == 3 && user[6] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[3] == 2 && user[0] == 3 && user[4] == 4) { // First - upper middle, second - middle left, third - upper left
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[3] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[3] == 2 && user[0] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[3] == 2 && user[4] == 3 && user[0] == 4) { // First - upper middle, second - middle left, third - middle
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[3] == 2 && user[4] == 3 && user[6] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[3] == 2 && user[4] == 3 && user[8] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[3] == 2 && user[5] == 3 && user[0] == 4) { // First - upper middle, second - middle left, third - middle right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[3] == 2 && user[5] == 3 && user[6] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[3] == 2 && user[5] == 3 && user[8] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[3] == 2 && user[6] == 3 && user[4] == 4) { // First - upper middle, second - middle left, third - lower left
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[3] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[3] == 2 && user[6] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[3] == 2 && user[8] == 3 && user[0] == 4) { // First - upper middle, second - middle left, third - lower right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[3] == 2 && user[8] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[3] == 2 && user[8] == 3 && user[6] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[4] == 2 && user[6] == 3 && user[0] == 4) { // First - upper middle, second - middle, third - lower left
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[4] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[4] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[5] == 2 && user[0] == 3 && user[3] == 4) { // First - upper middle, second - middle right, third - upper left
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[5] == 2 && user[0] == 3 && user[4] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[5] == 2 && user[0] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[5] == 2 && user[3] == 3 && user[0] == 4) { // First - upper middle, second - middle right, third - middle left
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[5] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[5] == 2 && user[3] == 3 && user[8] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[5] == 2 && user[4] == 3 && user[0] == 4) { // First - upper middle, second - middle right, third - middle
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[5] == 2 && user[4] == 3 && user[6] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[5] == 2 && user[4] == 3 && user[8] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[5] == 2 && user[6] == 3 && user[0] == 4) { // First - upper middle, second - middle right, third - lower left
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[5] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[5] == 2 && user[6] == 3 && user[8] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[5] == 2 && user[8] == 3 && user[0] == 4) { // First - upper middle, second - middle right, third - lower right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[5] == 2 && user[8] == 3 && user[3] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[5] == 2 && user[8] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[6] == 2 && user[0] == 3 && user[4] == 4) { // First - upper middle, second - lower left, third - upper left
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[6] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[1] == 1 && user[6] == 2 && user[0] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[6] == 2 && user[3] == 3 && user[4] == 4) { // First - upper middle, second - lower left, third - middle left
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[6] == 2 && user[3] == 3 && user[5] == 4) {
								cpu_move = 4;
							}
							else if (user[1] == 1 && user[6] == 2 && user[3] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[6] == 2 && user[4] == 3 && user[0] == 4) { // First - upper middle, second - lower left, third - middle
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[6] == 2 && user[4] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[6] == 2 && user[4] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[6] == 2 && user[5] == 3 && user[0] == 4) { // First - upper middle, second - lower left, third - middle right
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[6] == 2 && user[5] == 3 && user[3] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[6] == 2 && user[5] == 3 && user[8] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[6] == 2 && user[8] == 3 && user[0] == 4) { // First - upper middle, second - lower left, third - lower right
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[6] == 2 && user[8] == 3 && user[3] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[6] == 2 && user[8] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[8] == 2 && user[0] == 3 && user[3] == 4) { // First - upper middle, second - lower right, third - upper left
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[8] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[8] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[8] == 2 && user[3] == 3 && user[0] == 4) { // First - upper middle, second - lower right, third - middle left
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[8] == 2 && user[3] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[8] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 0;
							}
							else if (user[1] == 1 && user[8] == 2 && user[4] == 3 && user[3] == 4) { // First - upper middle, second - lower right, third - middle
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[8] == 2 && user[4] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[1] == 1 && user[8] == 2 && user[4] == 3 && user[6] == 4) {
								cpu_move = 5;
							}
							else if (user[1] == 1 && user[8] == 2 && user[5] == 3 && user[0] == 4) { // First - upper middle, second - lower right, third - middle right
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[8] == 2 && user[5] == 3 && user[3] == 4) {
								cpu_move = 6;
							}
							else if (user[1] == 1 && user[8] == 2 && user[5] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[0] == 2 && user[7] == 3 && user[3] == 4) { // First - upper right, second - upper left, third - lower middle
								cpu_move = 6;
							}
							else if (user[2] == 1 && user[0] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[2] == 1 && user[0] == 2 && user[7] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[1] == 2 && user[8] == 3 && user[3] == 4) { // First - upper right, second - upper middle, third - lower right
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[1] == 2 && user[8] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[1] == 2 && user[8] == 3 && user[7] == 4) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[3] == 2 && user[1] == 3 && user[5] == 4) { // First - upper right, second - middle left, third - upper middle
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[3] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[3] == 2 && user[1] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[2] == 1 && user[5] == 2 && user[0] == 3 && user[3] == 4) { // First - upper right, second - middle right, third - upper left
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[5] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 7;
							}
							else if (user[2] == 1 && user[5] == 2 && user[0] == 3 && user[7] == 4) {
								cpu_move = 6;
							}
							else if (user[2] == 1 && user[6] == 2 && user[1] == 3 && user[3] == 4) { // First - upper right, second - lower left, third - upper middle
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[6] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[2] == 1 && user[6] == 2 && user[1] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[2] == 1 && user[7] == 2 && user[0] == 3 && user[3] == 4) { // First - upper right, second - lower middle, third - upper left
								cpu_move = 6;
							}
							else if (user[2] == 1 && user[7] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[2] == 1 && user[7] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[2] == 1 && user[8] == 2 && user[3] == 3 && user[0] == 4) { // First - upper right, second - lower right, third - middle left
								cpu_move = 1;
							}
							else if (user[2] == 1 && user[8] == 2 && user[3] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
							else if (user[2] == 1 && user[8] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[0] == 2 && user[7] == 3 && user[1] == 4) { // First - middle left, second - upper left, third - lower middle
								cpu_move = 5;
							}
							else if (user[3] == 1 && user[0] == 2 && user[7] == 3 && user[4] == 4) {
								cpu_move = 5;
							}
							else if (user[3] == 1 && user[0] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[1] == 2 && user[7] == 3 && user[0] == 4) { // First - middle left, second - upper middle, third - lower middle
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[1] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[1] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[2] == 2 && user[7] == 3 && user[0] == 4) { // First - middle left, second - upper right, third - lower middle
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[2] == 2 && user[7] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[2] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[4] == 2 && user[0] == 3 && user[1] == 4) { // First - middle left, second - middle, third - upper left
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[0] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[4] == 2 && user[1] == 3 && user[0] == 4) { // First - middle left, second - middle, third - upper middle
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2 && user[1] == 3 && user[8] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[4] == 2 && user[2] == 3 && user[0] == 4) { // First - middle left, second - middle, third - upper right
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[4] == 2 && user[7] == 3 && user[0] == 4) { // First - middle left, second - middle, third - lower middle
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[4] == 2 && user[7] == 3 && user[8] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[4] == 2 && user[8] == 3 && user[1] == 4) { // First - middle left, second - middle, third - lower right
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[8] == 3 && user[2] == 4) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[4] == 2 && user[8] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[5] == 2 && user[2] == 3 && user[0] == 4) { // First - middle left, second - middle right, third - upper right
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[5] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[5] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[7] == 2 && user[0] == 3 && user[1] == 4) { // First - middle left, second - lower middle, third - upper left
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[7] == 2 && user[0] == 3 && user[4] == 4) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[7] == 2 && user[0] == 3 && user[8] == 4) {
								cpu_move = 4;
							}
							else if (user[3] == 1 && user[7] == 2 && user[1] == 3 && user[0] == 4) { // First - middle left, second - lower middle, third - upper middle
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[7] == 2 && user[1] == 3 && user[8] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[2] == 3 && user[0] == 4) { // First - middle left, second - lower middle, third - upper right
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[7] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[7] == 2 && user[2] == 3 && user[8] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[7] == 2 && user[4] == 3 && user[0] == 4) { // First - middle left, second - lower middle, third - middle
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[7] == 2 && user[4] == 3 && user[2] == 4) {
								cpu_move = 8;
							}
							else if (user[3] == 1 && user[7] == 2 && user[4] == 3 && user[8] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[7] == 2 && user[8] == 3 && user[0] == 4) { // First - middle left, second - lower middle, third - lower right
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[8] == 3 && user[1] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[7] == 2 && user[8] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[8] == 2 && user[0] == 3 && user[1] == 4) { // First - middle left, second - lower right, third - upper left
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[8] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[8] == 2 && user[0] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[8] == 2 && user[1] == 3 && user[0] == 4) { // First - middle left, second - lower right, third - upper middle
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[8] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[8] == 2 && user[1] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[8] == 2 && user[2] == 3 && user[0] == 4) { // First - middle left, second - lower right, third - upper right
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[8] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
							else if (user[3] == 1 && user[8] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[8] == 2 && user[4] == 3 && user[1] == 4) { // First - middle left, second - lower right, third - middle
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[8] == 2 && user[4] == 3 && user[2] == 4) {
								cpu_move = 7;
							}
							else if (user[3] == 1 && user[8] == 2 && user[4] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[3] == 1 && user[8] == 2 && user[7] == 3 && user[0] == 4) { // First - middle left, second - lower right, third - lower middle
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[8] == 2 && user[7] == 3 && user[1] == 4) {
								cpu_move = 2;
							}
							else if (user[3] == 1 && user[8] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[0] == 2 && user[7] == 3 && user[2] == 4) { // First - middle, second - upper left, third - lower middle
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[0] == 2 && user[7] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[0] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[1] == 2 && user[6] == 3 && user[0] == 4) { // First - middle, second - upper middle, third - lower left
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[1] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[1] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[2] == 2 && user[7] == 3 && user[0] == 4) { // First - middle, second - upper right, third - lower middle
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[2] == 2 && user[7] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[2] == 2 && user[7] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[3] == 2 && user[2] == 3 && user[0] == 4) { // First - middle, second - middle left, third - upper right
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[3] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[3] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[5] == 2 && user[0] == 3 && user[1] == 4) { // First - middle, second - middle right, third - upper left
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[5] == 2 && user[1] == 3 && user[0] == 4) { // First - middle, second - middle right, third - upper middle
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[5] == 2 && user[2] == 3 && user[0] == 4) { // First - middle, second - middle right, third - upper right
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[5] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[5] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 0;
							}
							else if (user[4] == 1 && user[5] == 2 && user[6] == 3 && user[0] == 4) { // First - middle, second - middle right, third - lower left
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[5] == 2 && user[6] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[5] == 2 && user[6] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[5] == 2 && user[7] == 3 && user[0] == 4) { // First - middle, second - middle right, third - lower middle
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[5] == 2 && user[7] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[6] == 2 && user[5] == 3 && user[0] == 4) { // First - middle, second - lower left, third - middle right
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[6] == 2 && user[5] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[4] == 1 && user[6] == 2 && user[5] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[4] == 1 && user[7] == 2 && user[0] == 3 && user[2] == 4) { // First - middle, second - lower middle, third - upper left
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[0] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[7] == 2 && user[2] == 3 && user[0] == 4) { // First - middle, second - lower middle, third - upper right
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[2] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[2] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[4] == 1 && user[7] == 2 && user[3] == 3 && user[0] == 4) { // First - middle, second - lower middle, third - middle left
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[7] == 2 && user[3] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[7] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[7] == 2 && user[5] == 3 && user[0] == 4) { // First - middle, second - lower middle, third - middle right
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[7] == 2 && user[5] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[4] == 1 && user[7] == 2 && user[5] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[4] == 1 && user[7] == 2 && user[6] == 3 && user[0] == 4) { // First - middle, second - lower middle, third - lower left
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[4] == 1 && user[7] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[0] == 2 && user[7] == 3 && user[1] == 4) { // First - middle right, second - upper left, third - lower middle
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[0] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[0] == 2 && user[7] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[1] == 2 && user[7] == 3 && user[0] == 4) { // First - middle right, second - upper middle, third - lower middle
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[1] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[1] == 2 && user[7] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[2] == 2 && user[6] == 3 && user[0] == 4) { // First - middle right, second - upper right, third - lower left
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[2] == 2 && user[6] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[2] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[3] == 2 && user[0] == 3 && user[1] == 4) { // First - middle right, second - middle left, third - upper left
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[3] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[3] == 2 && user[0] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[4] == 2 && user[0] == 3 && user[1] == 4) { // First - middle right, second - middle, third - upper left
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[4] == 2 && user[1] == 3 && user[0] == 4) { // First - middle right, second - middle, third - upper middle
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[4] == 2 && user[2] == 3 && user[0] == 4) { // First - middle right, second - middle, third - upper right
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[4] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[4] == 2 && user[2] == 3 && user[7] == 4) {
								cpu_move = 0;
							}
							else if (user[5] == 1 && user[4] == 2 && user[6] == 3 && user[0] == 4) { // First - middle right, second - middle, third - lower left
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[4] == 2 && user[6] == 3 && user[1] == 4) {
								cpu_move = 7;
							}
							else if (user[5] == 1 && user[4] == 2 && user[6] == 3 && user[7] == 4) {
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[4] == 2 && user[7] == 3 && user[0] == 4) { // First - middle right, second - middle, third - lower middle
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[7] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[5] == 1 && user[4] == 2 && user[7] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[6] == 2 && user[0] == 3 && user[1] == 4) { // First - middle right, second - lower left, third - upper left
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[6] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[6] == 2 && user[0] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[7] == 2 && user[0] == 3 && user[1] == 4) { // First - middle right, second - lower middle, third - upper left
								cpu_move = 2;
							}
							else if (user[5] == 1 && user[7] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[5] == 1 && user[7] == 2 && user[0] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[0] == 2 && user[5] == 3 && user[1] == 4) { // First - lower left, second - upper left, third - middle right
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[0] == 2 && user[5] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[0] == 2 && user[5] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[1] == 2 && user[3] == 3 && user[2] == 4) { // First - lower left, second - upper middle, third - middle left
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[1] == 2 && user[3] == 3 && user[7] == 4) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[1] == 2 && user[3] == 3 && user[8] == 4) {
								cpu_move = 7;
							}
							else if (user[6] == 1 && user[2] == 2 && user[1] == 3 && user[3] == 4) { // First - lower left, second - upper right, third - upper middle
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[2] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 8;
							}
							else if (user[6] == 1 && user[2] == 2 && user[1] == 3 && user[8] == 4) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[3] == 2 && user[8] == 3 && user[1] == 4) { // First - lower left, second - middle left, third - lower right
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[3] == 2 && user[8] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[3] == 2 && user[8] == 3 && user[5] == 4) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[5] == 2 && user[0] == 3 && user[1] == 4) { // First - lower left, second - middle right, third - upper left
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[5] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[6] == 1 && user[5] == 2 && user[0] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[7] == 2 && user[0] == 3 && user[1] == 4) { // First - lower left, second - lower middle, third - upper left
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[7] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 5;
							}
							else if (user[6] == 1 && user[7] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 2;
							}
							else if (user[6] == 1 && user[8] == 2 && user[1] == 3 && user[0] == 4) { // First - lower left, second - lower right, third - upper middle
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[8] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 3;
							}
							else if (user[6] == 1 && user[8] == 2 && user[1] == 3 && user[3] == 4) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[0] == 2 && user[1] == 3 && user[3] == 4) { // First - lower middle, second - upper left, third - upper middle
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[0] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[0] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[0] == 2 && user[2] == 3 && user[3] == 4) { // First - lower middle, second - upper left, third - upper right
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[0] == 2 && user[2] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[0] == 2 && user[2] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[0] == 2 && user[3] == 3 && user[1] == 4) { // First - lower middle, second - upper left, third - middle left
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[0] == 2 && user[3] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[0] == 2 && user[3] == 3 && user[5] == 4) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[0] == 2 && user[5] == 3 && user[1] == 4) { // First - lower middle, second - upper left, third - middle right
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[0] == 2 && user[5] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[0] == 2 && user[5] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[0] == 2 && user[6] == 3 && user[1] == 4) { // First - lower middle, second - upper left, third - lower left
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[0] == 2 && user[6] == 3 && user[2] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[0] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[1] == 2 && user[0] == 3 && user[3] == 4) { // First - lower middle, second - upper middle, third - upper left
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[1] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[1] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[2] == 2 && user[0] == 3 && user[3] == 4) { // First - lower middle, second - upper right, third - upper left
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[2] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[2] == 2 && user[0] == 3 && user[6] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[3] == 2 && user[5] == 3 && user[0] == 4) { // First - lower middle, second - middle left, third - middle right
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[3] == 2 && user[5] == 3 && user[1] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[3] == 2 && user[5] == 3 && user[6] == 4) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[4] == 2 && user[0] == 3 && user[2] == 4) { // First - lower middle, second - middle, third - upper left
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[0] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[0] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[4] == 2 && user[2] == 3 && user[0] == 4) { // First - lower middle, second - middle, third - upper right
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[2] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[2] == 3 && user[5] == 4) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[4] == 2 && user[3] == 3 && user[0] == 4) { // First - lower middle, second - middle, third - middle left
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[4] == 2 && user[3] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[4] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[4] == 2 && user[5] == 3 && user[0] == 4) { // First - lower middle, second - middle, third - middle right
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[4] == 2 && user[5] == 3 && user[2] == 4) {
								cpu_move = 6;
							}
							else if (user[7] == 1 && user[4] == 2 && user[5] == 3 && user[6] == 4) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[4] == 2 && user[6] == 3 && user[0] == 4) { // First - lower middle, second - middle, third - lower left
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 5;
							}
							else if (user[7] == 1 && user[4] == 2 && user[6] == 3 && user[5] == 4) {
								cpu_move = 0;
							}
							else if (user[7] == 1 && user[5] == 2 && user[0] == 3 && user[1] == 4) { // First - lower middle, second - middle right, third - upper left
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[5] == 2 && user[0] == 3 && user[2] == 4) {
								cpu_move = 1;
							}
							else if (user[7] == 1 && user[5] == 2 && user[0] == 3 && user[3] == 4) {
								cpu_move = 2;
							}
							else if (user[7] == 1 && user[6] == 2 && user[2] == 3 && user[0] == 4) { // First - lower middle, second - lower left, third - upper right
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[6] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 3;
							}
							else if (user[7] == 1 && user[6] == 2 && user[2] == 3 && user[3] == 4) {
								cpu_move = 0;
							}
							else if (user[8] == 1 && user[0] == 2 && user[1] == 3 && user[3] == 4) { // First - lower right, second - upper left, third - upper middle
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[0] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[0] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[1] == 2 && user[3] == 3 && user[0] == 4) { // First - lower right, second - upper middle, third - middle left
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[1] == 2 && user[3] == 3 && user[2] == 4) {
								cpu_move = 0;
							}
							else if (user[8] == 1 && user[1] == 2 && user[3] == 3 && user[7] == 4) {
								cpu_move = 2;
							}
							else if (user[8] == 1 && user[2] == 2 && user[3] == 3 && user[0] == 4) { // First - lower right, second - upper right, third - middle left
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[2] == 2 && user[3] == 3 && user[1] == 4) {
								cpu_move = 0;
							}
							else if (user[8] == 1 && user[2] == 2 && user[3] == 3 && user[6] == 4) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[3] == 2 && user[1] == 3 && user[0] == 4) { // First - lower right, second - middle left, third - upper middle
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[3] == 2 && user[1] == 3 && user[5] == 4) {
								cpu_move = 6;
							}
							else if (user[8] == 1 && user[3] == 2 && user[1] == 3 && user[6] == 4) {
								cpu_move = 0;
							}
							else if (user[8] == 1 && user[5] == 2 && user[6] == 3 && user[0] == 4) { // First - lower right, second - middle right, third - lower left
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[5] == 2 && user[6] == 3 && user[1] == 4) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[5] == 2 && user[6] == 3 && user[3] == 4) {
								cpu_move = 1;
							}
							else if (user[8] == 1 && user[6] == 2 && user[1] == 3 && user[0] == 4) { // First - lower right, second - lower left, third - upper middle
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[6] == 2 && user[1] == 3 && user[2] == 4) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[6] == 2 && user[1] == 3 && user[3] == 4) {
								cpu_move = 0;
							}
							else if (user[8] == 1 && user[7] == 2 && user[2] == 3 && user[0] == 4) { // First - lower right, second - lower middle, third - upper right
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[7] == 2 && user[2] == 3 && user[1] == 4) {
								cpu_move = 3;
							}
							else if (user[8] == 1 && user[7] == 2 && user[2] == 3 && user[3] == 4) {
								cpu_move = 1;
							}
							

						}
					}
					used[cpu_move] =2;
					setTextSize(6);
					setTextColor(WHITE);
					move++;
					if (cpu_move==0)
					{
						drawCircle(43,130,22,WHITE);
						drawCircle(43,130,23,WHITE);
						drawCircle(43,130,24,WHITE);
						drawCircle(43,130,25,WHITE);
					}
					else if (cpu_move==1)
					{
						drawCircle(123,130,22,WHITE);
						drawCircle(123,130,23,WHITE);
						drawCircle(123,130,24,WHITE);
						drawCircle(123,130,25,WHITE);
					}
					else if (cpu_move==2)
					{
						drawCircle(200,130,22,WHITE);
						drawCircle(200,130,23,WHITE);
						drawCircle(200,130,24,WHITE);
						drawCircle(200,130,25,WHITE);
					}
					else if (cpu_move==3)
					{
						drawCircle(43,207,22,WHITE);
						drawCircle(43,207,23,WHITE);
						drawCircle(43,207,24,WHITE);
						drawCircle(43,207,25,WHITE);
					}
					else if (cpu_move==4)
					{
						drawCircle(123,207,22,WHITE);
						drawCircle(123,207,23,WHITE);
						drawCircle(123,207,24,WHITE);
						drawCircle(123,207,25,WHITE);
					}
					else if (cpu_move==5)
					{
						drawCircle(200,207,22,WHITE);
						drawCircle(200,207,23,WHITE);
						drawCircle(200,207,24,WHITE);
						drawCircle(200,207,25,WHITE);
					}
					else if (cpu_move==6)
					{
						drawCircle(43,283,22,WHITE);
						drawCircle(43,283,23,WHITE);
						drawCircle(43,283,24,WHITE);
						drawCircle(43,283,25,WHITE);
					}
					else if (cpu_move==7)
					{
						drawCircle(123,283,22,WHITE);
						drawCircle(123,283,23,WHITE);
						drawCircle(123,283,24,WHITE);
						drawCircle(123,283,25,WHITE);
					}
					else if (cpu_move==8)
					{
						drawCircle(200,283,22,WHITE);
						drawCircle(200,283,23,WHITE);
						drawCircle(200,283,24,WHITE);
						drawCircle(200,283,25,WHITE);
					}
					if (used[0]==2 && used[1]==2 && used[2]==2)
					{
						drawLine(0,130,240,130,WHITE);
						drawLine(0,131,240,131,WHITE);
						drawLine(0,132,240,132,WHITE);
						drawLine(0,133,240,133,WHITE);
						win=2;
					}
					else if (used[3]==2 && used[4]==2 && used[5]==2)
					{
						drawLine(0,210,240,210,WHITE);
						drawLine(0,211,240,211,WHITE);
						drawLine(0,212,240,212,WHITE);
						drawLine(0,213,240,213,WHITE);
						win=2;
					}
					else if (used[6]==2 && used[7]==2 && used[8]==2)
					{
						drawLine(0,285,240,285,WHITE);
						drawLine(0,286,240,286,WHITE);
						drawLine(0,287,240,287,WHITE);
						drawLine(0,288,240,288,WHITE);
						win=2;
					}
					else if (used[0]==2 && used[3]==2 && used[6]==2)
					{
						drawLine(40,100,40,320,WHITE);
						drawLine(41,100,41,320,WHITE);
						drawLine(42,100,42,320,WHITE);
						drawLine(43,100,43,320,WHITE);
						win=2;
					}
					else if (used[1]==2 && used[4]==2 && used[7]==2)
					{
						drawLine(120,100,120,320,WHITE);
						drawLine(121,100,121,320,WHITE);
						drawLine(122,100,122,320,WHITE);
						drawLine(123,100,123,320,WHITE);
						win=2;
					}
					else if (used[2]==2 && used[5]==2 && used[8]==2)
					{
						drawLine(200,100,200,320,WHITE);
						drawLine(201,100,201,320,WHITE);
						drawLine(202,100,202,320,WHITE);
						drawLine(203,100,203,320,WHITE);
						win=2;
					}
					else if (used[0]==2 && used[4]==2 && used[8]==2)
					{
						drawLine(2,102,238,320,WHITE);
						drawLine(1,101,239,320,WHITE);
						drawLine(0,100,240,320,WHITE);
						drawLine(1,101,240,319,WHITE);
						drawLine(2,102,240,318,WHITE);
						win=2;
					}
					else if (used[2]==2 && used[4]==2 && used[6]==2)
					{
						drawLine(238,102,2,318,WHITE);
						drawLine(239,101,1,319,WHITE);
						drawLine(240,100,0,320,WHITE);
						drawLine(240,101,1,320,WHITE);
						drawLine(240,102,2,320,WHITE);
						win=2;
					}		
				}
				if (cpu_start==2)
				{
					cpu_start=1;
				}
				if (win==0)
				{
					if (used[0] !=0 && used[1] !=0 && used[2] !=0 && used[3] !=0 && used[4] !=0 && used[5] !=0 && 
						used[6] !=0 && used[7] !=0 && used[8] !=0)
						{
							win=3;
						}
				}
				if (win!=0)
				{
					user_move=1;
					if (cpu_start==0)
					{
						cpu_start=1;
					}
					else
					{
						cpu_start=0;
					}
					if (win!=3)
					{
						_delay_ms(2000);
					}
					fillRect(0,100,79,70,BLACK);
					fillRect(83,100,78,70,BLACK);
					fillRect(164,100,80,70,BLACK);
					fillRect(0,174,79,70,BLACK);
					fillRect(83,174,78,70,BLACK);
					fillRect(164,174,80,70,BLACK);
					fillRect(0,247,79,75,BLACK);
					fillRect(83,247,78,75,BLACK);
					fillRect(164,247,80,75,BLACK);
					drawLine(79,100,79,316,BLUE);
					drawLine(80,100,80,316,BLUE);
					drawLine(81,100,81,316,BLUE);
					drawLine(82,100,82,316,BLUE);
					drawLine(160,100,160,316,BLUE);
					drawLine(161,100,161,316,BLUE);
					drawLine(162,100,162,316,BLUE);
					drawLine(163,100,163,316,BLUE);
					drawLine(10,170,230,170,BLUE);
					drawLine(10,171,230,171,BLUE);
					drawLine(10,172,230,172,BLUE);
					drawLine(10,173,230,173,BLUE);
					drawLine(10,244,230,244,BLUE);
					drawLine(10,245,230,245,BLUE);
					drawLine(10,246,230,246,BLUE);
					drawLine(10,247,230,247,BLUE);
					for (int i=0; i<9;i++)
					{
						used[i]=0;
						user[i]=0;
					}
					touched=0;
					touch_index=0;
					move=0;
					if(win==1)
					{
						player++;
						sprintf(buff,"%d\n",player);
						fillRect(0,25,60,35,BLACK);
						setTextSize(4);
						setTextColor(WHITE);
						if(player>10)
						{
							setCursor(15,25);
						}
						else
						{
							setCursor(25,25);
						}
						drawString(buff);
					}
					else if (win==2)
					{
						cpu++;
						sprintf(buff,"%d\n",cpu);
						fillRect(190,25,60,35,BLACK);
						setTextSize(4);
						setTextColor(WHITE);
						if(cpu>10)
						{
							setCursor(187,25);
						}
						else
						{
							setCursor(197,25);
						}
						drawString(buff);
					}
					else if (win==3)
					{
						tie++;
						sprintf(buff,"%d\n",tie);
						fillRect(105,25,60,35,BLACK);
						setTextSize(4);
						setTextColor(WHITE);
						if(tie>10)
						{
							setCursor(102,25);
						}
						else
						{
							setCursor(112,25);
						}
						drawString(buff);
					}
					win=0;
				}
			}
		}
	}
}
